package com.jpattern.orm.query;

import com.jpattern.orm.exception.OrmException;

/**
 * 
 * @author Francesco Cina
 *
 * 07/lug/2011
 */
public interface CustomFindQuery extends OrmBaseFindQuery<CustomFindQuery>, ICustomQuery {

	/**
	 * Set the maximum number of rows to return in the query.
	 * @param maxRows
	 * @return
	 */
	@Override
	CustomFindQuery setMaxRows(int maxRows) throws OrmException;

	/**
	 * Set the query timeout for the query.
	 */
	@Override
	CustomFindQuery setQueryTimeout(int queryTimeout);

	/**
	 * 
	 * @param lockMode
	 * @return
	 */
	CustomFindQuery setLockMode(LockMode lockMode);
}
