package com.jpattern.orm.query;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.query.clause.From;
import com.jpattern.orm.query.clause.OrderBy;
import com.jpattern.orm.query.clause.Where;

/**
 * 
 * @author Francesco Cina
 *
 * 08/lug/2011
 */
public interface OrmBaseFindQuery<T extends IQueryRoot> extends BaseFindQuery {

	/**
	 * Add join tables to the from clause.
	 * @return
	 */
	public abstract From<T> from() throws OrmException;

	/**
	 * Set the where clause.
	 * @return
	 */
	public abstract Where<T> where() throws OrmException;

	/**
	 * Set the order by clause.
	 * @return
	 */
	public abstract OrderBy<T> orderBy() throws OrmException;

}
